@echo off
:: By Jared Allard.
:: (c) 2012 RD CODING INC
:: Tweak all you want.
:: Licensed under "Creative Commons"
:: Offical Debug version.
::------------------------------------
::-          Change Log              -
::------------------------------------
:: V1.0 Added menu selections, and basic startup.
:: V1.5 Added boot mode selection, code by KFU. Retweaked by me.
:: V2.1 Numerous bug fixes, started on a OTA system.
:: V3.0 Root added, recovery beta, were making progeress!
::
rem Changelog is no longer being updated here.
rem it is being updated at the "ChangeLog" menu.
::------------------------------------
@echo off
color 0c

rem version
set cver=8.0
set cdate=(12/1/2012)
set url=
set changelog=
set updatename=Latest_Utility.zip
set updatelocation=/%updatename%

set lver=
set ldate=
set lurl=
rem for future.
set lchangelog=

rem Establish Varabiles
set tmp=""
rem reset - title
set title= title [RDC] LG Vortex Utility V%cver%
rem ADB - location
set adb= files\adb
set fastboot= files\fastboot
rem sleep - pause the prompt for %st% amount of time
set sleep= files\sleep %st%
rem adbs - Start the server
set adbs= files\adb start-server
rem adbk - Kill the adb server
set adbk= files\adb kill-server
rem st - 'Sleeptime'
set st=
rem location - Where roms are located
set location=/sdcard/roms
rem adbd - adb devices
set adbd=cmd /k files\adb devices

rem MD5's (BECAREFUL WHEN EDITING THESE!)

set pbtitle=call:pbtitle

set md5check=

set md5stockrimg=BE192CCEFE712D6F051426C1C39D64BB

set md5customrimg=E47260EE2B5294585002AE8519131012

%title%

:Start
cls
echo **************************************************
echo *                   LG VORTEX                    *
ECHO *                    UTILITY                     *
ECHO *                     V8.0                       *
ECHO **************************************************
ECHO *            Microsoft Windows Version.          *
ECHO *             (c) 2012 RD CODING INC             *
ECHO *                 Jared Allard                   *
ECHO **************************************************
rem YES Update Notifeir! And the ability too update links incase of emergencys!
ECHO Is intialising. Please wait...
set t=0 
%pbtitle%
START /MIN cmd /c del /q /f files\ver.log
START /MIN cmd /c del /q /f files\url.log
START /MIN cmd /c del /q /f files\date.log
set t=20
%pbtitle%
files\wget -q -O files\url.log http://goo.gl/CwKCT
SET /P lurl=<files\url.log
set t=40
%pbtitle%
files\wget -q -O files\ver.log http://goo.gl/xIK2G
SET /P lver=<files\ver.log
set t=60
%pbtitle%
files\wget -q -O files\date.log http://goo.gl/lgXGF
SET /P ldate=<files\date.log
set current=
files\wget -q -O files\changelog.log http://goo.gl/aKjZi
SET /P lchangelog=<files\changelog.log
set t=80
%pbtitle%
if %lver% == %cver% set current= Version %lver% - %ldate%
if NOT %lver% == %cver%	set current= NEW VERSION %lver% - %ldate%
set t=100
%pbtitle%
files\sleep 1
%title%
if NOT %lver% == %cver% call:update

rem debug
rem set | findstr /s 7
rem pause
GOTO:menu_loop


:menu_loop
	cls
	call:header
	for /f "tokens=1,2,* delims=_ " %%A in ('"findstr /b /c:":option_" "%~f0""') do echo.  %%B  %%C

	set choice=
	echo.&set /p choice=Please make a selection or hit ENTER to exit: ||GOTO:exit
	echo.&call:option_%choice%
goto:eof
	
	
::Options

:option_1 ADB Terminal 
	echo. - Killing previous instances of ADB..
	%adbk%
	files\sleep 5
	echo. - Done!
	files\sleep 3
	cls
	call:header
	echo. - We are now entering an ADB terminal...
	files\sleep 3
	cls
	call:done
	
	call:adbnetwork
	echo. Type "Exit" too exit.
	%adbs%
	cd files
	cmd /k adb devices
	echo. Exiting...
	cd..
	%adk%
	goto:menu_loop
	
:exit
	echo. - Killing ADB Shell...
	%adbk%
	files\sleep 2
	echo. Thanks for using this Utility!
	files\sleep 2
	exit
	goto:menu_loop
	
:option_2 Boot Menu
	cls
	call:bootheader
	
	for /f "tokens=1,2,* delims=_ " %%A in ('"findstr /b /c:":boot_" "%~f0""') do echo.  %%B  %%C
	
	set choice=
	echo.&set /p choice=Please make a selection or hit ENTER to return: ||GOTO:menu_loop
	echo.&call:boot_%choice%
	GOTO:EOF
	
:option_3 Adb Shell (Device)
	call:adbnetwork
	files\adb shell
	files\adb kill-server
	echo Closing Connection...
	files\sleep 5
	GOTO:menu_loop
	
:option_4 Change Log
	cls
	call:changelog
	pause
	GOTO:menu_loop	
	
:option_5 Root
	call:root_loop
	GOTO:menu_loop
	
:option_6 Recovery
	call:recovery_loop
	files\sleep 5
	GOTO:menu_loop
	
:option_7 All-in-One
	call:root_loop
	call:recovery_loop
	files\sleep 5
	goto:menu_loop
	
:option_8 ROM Menu
	rem Oh boy...
	call:roml_loop

:option_9 Donate!
	start roms/links/Donate_to_Utility_Developer!.url
	goto:menu_loop
	
:option_10 Extras
	cls
	call:extrasheader
	
	for /f "tokens=1,2,* delims=_ " %%A in ('"findstr /b /c:":extra_" "%~f0""') do echo.  %%B  %%C
	
	set choice=
	echo.&set /p choice=Please make a selection or hit ENTER to return: ||GOTO:menu_loop
	echo.&call:extra_%choice%
	
	
:option_11 Check for Updates
	cls
	echo Checking for an Update...
	files\sleep 1
	echo Connecting to servers...
	files\sleep 2
	if %lver% == %cver% call:noupdate
	if NOT %lver% == %cver% call:update
goto:eof

:option_12 Exit
	set tmps=""
	echo. - Killing ADB
	files\adb kill-server
	files\sleep 2
	echo. - Exiting....
	files\sleep 2
	exit

::Functions

:header
	echo. *****************************************
	echo. *        LG VORTEX UTILITY 8.0          *
	echo. *****************************************
	echo. *Please report bugs too the forum thread*
	echo. *****************************************
	echo. %current%
	echo.
	GOTO:EOF
	
:headerrom
	echo. *****************************************
	echo. *               ROM Menu                *
	echo. *****************************************
	echo. *        Support the Developers!        *
	echo. *****************************************
	GOTO:EOF
	
:done
	echo.***************************************
	echo.*            ADB TERMINAL             *
	echo.***************************************
	echo.*             By Google               *
	echo.***************************************    
	GOTO:EOF
	
:recoverygnm
	echo Initializing...
	%sleep% 1
	rem -----------------------------
	rem modify adb network for network adb.
	call:adbnetwork
	rem -----------------------------
	files\adb devices
	echo If you get an empty "List of Devices" stop here.
	pause
	echo Device Connected. 
	echo Sending files....
	echo --------------------------------------
	files\adb push recoveryflash /sdcard/recoveryflash
	echo Complete! Files Have succesfully been sent.
	echo All Files have been prepared. Begin Flashing?
	echo Requires root
	timeout 15
	cls
	echo                      RECOVERY GNM 3.06
	echo ---------------------------------------------------------------
	echo Starting Recovery Flashing Process. (Highly Expiremental) (Works)
	files\sleep 5
	echo Running Psnueter exploit to allow root.
	echo -----------------------------------------------------------------
	files\adb shell mkdir /data/local/tmp
	files\adb push root/psneuter /data/local/tmp/psneuter
	files\adb shell chmod 755 /data/local/tmp/psneuter
	files\adb shell /data/local/tmp/psneuter
	files\sleep 3
	echo Mounting System as RW...
	echo -----------------------------------------------------------------
	cmd /c files\adb shell mount -o remount,rw -t yaffs2 /dev/block/mtdblock4  /system
	files\adb remount rw
	files\sleep 2
	echo Pushing "recoveryflash.sh" to /data/local/recoveryflash.sh
	echo -----------------------------------------------------------------
	files\adb push recoveryflash/recoveryflash.sh  /data/local/recoveryflash.sh
	files\sleep 2
	echo CHMODING "recoveryflash.sh" as excutable.
	echo -----------------------------------------------------------------
	cmd /c files\adb shell chmod 0755 /data/local/recoveryflash.sh
	files\sleep 2
	echo Flashing Recovery....
	echo -----------------------------------------------------------------
	cmd /c files\adb shell /data/local/recoveryflash.sh
	files\sleep 2
	echo Your device should now reboot.
	echo -----------------------------------------------------------------
	files\sleep 5
	echo That's all! You should now have a custom recovery!
	echo ---------------------------------------------------------------
	timeout 10
	GOTO:menu_loop
	
:recoverystock
	echo Checking if Stockrecovery.img and stockrecoveryflash.sh exist....
	timeout 5
	IF EXIST recoveryflash\stockrecovery.img (
		echo. stockrecovery.img has been found.
		echo.
	) else (
		echo. stockrecovery.img is missing.
		echo. So we will download it for you!
		echo.
		
		call:download_stock_recovery
	)
	IF EXIST recoveryflash\stockrecoveryflash.sh (
		echo. stockrecoveryflash.sh has been found.
		echo.
	) else (
		echo. stockrecoveryflash.sh is missing.
		echo. So we will download it for you!
		echo.
		
		call:download_stock_recoveryflash
	)
	cls
	rem temp fix to MD5 check errors.
	set md5check=BE192CCEFE712D6F051426C1C39D64BB
	%title%
	echo Checking MD5 of Stockrecovery.img
	
	for /f "tokens=1" %%a in ( 'tools\md5 recoveryflash\stockrecovery.img' ) do ( set md5check=%%a )
	
	if "%md5check%" == "%md5stockrimg%" (
		cls 
		echo MD5 is Correct.
		set st=5
		%sleep%
	) else (
		pause
		cls
		echo.
		echo. ***********************************************
		echo. *                   WARNING                   *
		echo. ***********************************************
		echo.
		echo. MD5 did not match. Aborting.
		goto;menu_loop
		pause
	)
	rem -----------------------------
	rem modify adb network for network adb.
	call:adbnetwork
	rem -----------------------------
	echo Files have been downloaded.
	echo --------------------------------------------------------------------
	files\adb devices
	echo If you get an empty "List of Devices" stop here.
	pause
	echo Device Connected. 
	echo Sending files....
	echo -----------------------------------------------
	files\adb push recoveryflash /sdcard/recoveryflash
	echo Complete! Files Have succesfully been sent.
	echo All Files have been prepared. Begin Flashing?
	echo -----------------------------------------------
	echo Requires root
	timeout 15
	cls
	echo                      STOCK RECOVERY
	echo ---------------------------------------------------------------
	echo Starting Recovery Flashing Process.
	files\sleep 5
	echo Running Psnueter exploit to allow root.
	echo -----------------------------------------------------------------
	files\adb shell mkdir /data/local/tmp
	files\adb push root/psneuter /data/local/tmp/psneuter
	files\adb shell chmod 755 /data/local/tmp/psneuter
	files\adb shell /data/local/tmp/psneuter
	files\sleep 3
	echo Mounting System as RW...
	echo -----------------------------------------------------------------
	cmd /c files\adb shell mount -o remount,rw -t yaffs2 /dev/block/mtdblock4  /system
	files\adb remount rw
	files\sleep 2
	echo Pushing "stockrecoveryflash.sh" to /data/local/stockrecoveryflash.sh
	echo -----------------------------------------------------------------
	files\adb push recoveryflash/stockrecoveryflash.sh  /data/local/stockrecoveryflash.sh
	files\sleep 2
	echo CHMODING "stockrecoveryflash.sh" as excutable.
	echo -----------------------------------------------------------------
	cmd /c files\adb shell chmod 0755 /data/local/stockrecoveryflash.sh
	files\sleep 2
	echo Please note this is a modified version of the recoveryflasher
	echo for a custom recovery. It may have bugs/issues.
	timeout 10
	echo Flashing Recovery....
	echo -----------------------------------------------------------------
	cmd /c files\adb shell /data/local/stockrecoveryflash.sh
	files\sleep 2
	echo Your device should now reboot.
	echo -----------------------------------------------------------------
	files\sleep 5
	echo ---------------------------------------------------------------
	timeout 10
	GOTO:menu_loop
	pause
	goto:menu_loop
	
:rootzergrush
	echo Can't get ADB on your device? Then use Network ADB!
	echo (Needs root, or have a rom that supports it.)
	echo (You'll have to open the .bat for network config.)
	pause
	cls
	rem --------------------------------------------------
	rem FOR NETWORK ADB (IP + PORT) UN-REM 'adb connect' in :adbnetwork
	call:adbnetwork
	rem --------------------------------------------------
	files\adb devices
	echo Got and empty "List of Devices?" Stop here.
	timeout 10
	cls
	echo                     ZERGRUSH ROOT EXPLOIT
	echo -----------------------------------------------------------------
	files\adb remount
	echo Creating directory "tmp" at "/data/local/tmp"
	echo -----------------------------------------------------------------
	cmd /c files\adb shell mkdir /data/local/tmp
	files\sleep 2
	echo Sending "zergrush" to "/data/local/tmp"
	echo -----------------------------------------------------------------
	files\adb push root/zergRush /data/local/tmp/zergRush
	files\sleep 2
	echo CHMODING "755" Zergrush
	echo -----------------------------------------------------------------
	cmd /c files\adb shell chmod 755 /data/local/tmp/zergRush
	files\sleep 2
	echo Sending "BusyBox" to "/data/local/tmp"
	echo -----------------------------------------------------------------
	files\adb push root/BusyBox /data/local/tmp/BusyBox
	files\sleep 2
	echo CHMODING "755" BusyBox
	echo -----------------------------------------------------------------
	files\adb shell chmod 755 /data/local/tmp/BusyBox
	files\sleep 2
	Echo Starting ZergRush...
	echo -----------------------------------------------------------------
	files\adb shell /data/local/tmp/zergRush
	files\sleep 5
	echo Mounting system as Read-Write
	echo -----------------------------------------------------------------
	files\adb remount
	files\sleep 2
	echo Sending "BusyBox" to /system/
	echo -----------------------------------------------------------------
	files\adb shell dd if=/data/local/tmp/BusyBox of=/system/xbin/busybox
	files\adb shell chown root.shell /system/xbin/busybox
	files\adb shell chmod 04755 /system/xbin/busybox
	files\sleep 2
	echo Installing BusyBox
	echo -----------------------------------------------------------------
	files\adb shell /system/xbin/busybox --install -s /system/xbin
	files\sleep 2
	echo Pushing SU to "/system/bin" and "/system/xbin"
	echo -----------------------------------------------------------------
	files\adb push root/su /system/bin
	files\adb push root/su /system/xbin
	sleep 2
	echo CHMODING "4755" SU
	echo -----------------------------------------------------------------
	cmd /c files\adb shell chmod 4755 /system/bin/su
	cmd /c files\adb shell chmod 4755 /system/xbin/su
	sleep 2
	echo Installing Superuser.apk
	echo -----------------------------------------------------------------
	files\adb install root\Superuser.apk
	files\sleep 2
	echo Rebooting Phone...
	echo -----------------------------------------------------------------
	files\adb reboot
	files\sleep 5
	echo ----------------------------------------------------------
	call:rootcomplete
	timeout 10
	goto:eof

:rootratc
	echo Can't get ADB on your device? Then use Network ADB!
	echo (Needs root, or have a rom that supports it.)
	echo (You'll have to open the .bat for network config.)
	pause
	cls
	rem --------------------------------------------------
	rem FOR NETWORK ADB (IP + PORT) UN-REM "adb connect"
	call:adbnetwork
	rem --------------------------------------------------
	files\adb devices
	echo Got and empty "List of Devices?" Stop here.
	timeout 10
	cls
	echo                   PSNEUTER ROOT EXPLOIT
	echo ---------------------------------------------------------------
	echo Running Psnueter exploit to allow root.
	echo -----------------------------------------------------------------
	files\adb shell mkdir /data/local/tmp
	files\adb push root/psneuter /data/local/tmp/psneuter
	files\adb shell chmod 755 /data/local/tmp/psneuter
	files\adb shell /data/local/tmp/psneuter
	files\sleep 2
	echo Mounting System as Writeable.
	echo -----------------------------------------------------------------
	cmd /c files\adb shell mount -o remount,rw -t yaffs2 /dev/block/mtdblock4  /system
	files\sleep 2
	Echo Mounting Failed. Trying Alternative method.
	echo -----------------------------------------------------------------
	files\adb remount rw
	files\sleep 5
	echo Sending "BusyBox" to /system/
	echo -----------------------------------------------------------------
	files\adb shell dd if=/data/local/tmp/BusyBox of=/system/xbin/busybox
	files\adb shell chown root.shell /system/xbin/busybox
	files\adb shell chmod 04755 /system/xbin/busybox
	files\sleep 2
	echo Installing BusyBox
	echo -----------------------------------------------------------------
	files\adb shell /system/xbin/busybox --install -s /system/xbin
	files\sleep 2
	echo Pushing SU...
	echo -----------------------------------------------------------------
	cmd /c files\adb push root\su /system/xbin/su
	cmd /c files\adb push root\su /system/bin/su
	files\sleep 2
	echo Setting Parameters...
	echo -----------------------------------------------------------------
	cmd /c files\adb shell chown 0.0 /system/xbin/su
	cmd /c files\adb shell chown 0.0 /system/bin/su
	files\sleep 2
	echo Setting Permissions to Excutable.
	echo -----------------------------------------------------------------
    cmd /c files\adb shell chmod 06755 /system/xbin/su
	cmd /c files\adb shell chmod 06755 /system/bin/su
	fless\sleep 2
	echo Installing SuperUser.
	echo -----------------------------------------------------------------
	files\adb push root\Superuser.apk /system/app/Superuser.apk
	files\adb install root\Superuser.apk
	files\sleep 2
	echo Rebooting Phone
	echo -----------------------------------------------------------------
	files\adb reboot
	echo That's all folks.
	echo ----------------------------------------------------------------
	timeout 10
	cls
goto:eof

:changelog
	echo -
	echo ------------------------------------
	echo By Jared Allard.
	echo (C) 2012 RD CODING INC
	echo Licensed under "Creative Commons"
	echo ------------------------------------
	echo -          Change Log              -
	echo ------------------------------------
	echo  V1.0 Added menu selections, and basic startup.
	echo  V1.5 Added boot mode selection, code by KFU. Retweaked by me.
	echo  V2.1 NUMEROUS bug fixes, and feature additions.
	echo  ---- Released
	echo  V3.0 Root working, Recovery beta, were making progeress. ;)
	echo  V3.4 (OB) Recovery should work. Boot menu too.
	echo  V4.0 (EB) Everything Broke. Rebuilding.
	echo  V5.0 (OB) Everything was fixed.
	echo  V6.5 (OB) Small Bug Fixes, added in MD5CHECK compenents. Fixed a
	echo   bit of issues with adb network and with the img dl. Added in ROMS
	echo   menu, that includes forums links, etc.
	echo ------------------------------------
	rem Credits
	echo -
	echo ------------------------------------
	echo -            Credits               -
	echo - Developer: Jared631(Jared Allard)-
	echo - Supporter: Trevor (Friend :3)    -
	echo - My Cat, George, for pissin me off-
	echo _ ROM Developers! Shoutout to BobZ!-
	echo ------------------------------------
	echo -
	rem Disclaimer
	echo ------------------------------------
	echo * 
	echo * include std_disclaimer
	echo *
	echo * Your warranty is now void.
	echo *
	echo * I am not responsible for bricked devices, dead SD cards,
	echo * thermonuclear war, or you getting fired because the alarm app failed. Please
	echo * do some research if you have any concerns about features included in this Utility
	echo * before using it! YOU are choosing to make these modifications, and if
	echo * you point the finger at me for messing up your device, I will laugh at you.
	echo *
	echo ------------------------------------
	goto:EOF

:adbnetwork
	rem Un rem 'adb connect' for adb network.
	rem files\adb connect 0.0.0.0:5555 & rem IP AND PORT HERE i.e 192.168.0.111:5555
goto:eof
	
::Sub Menus

:pbar
	:: Calculate the number of vertical bars then spaces based on the percentage value passed
	SETLOCAL ENABLEDELAYEDEXPANSION
	SET ProgressPercent=%1
	SET /A NumBars=%ProgressPercent%/2
	SET /A NumSpaces=50-%NumBars%

	:: Clear the progress meter image
	SET Meter=

	:: Build the meter image using vertical bars followed by trailing spaces
	:: Note there is a trailing space at the end of the second line below
	FOR /L %%A IN (%NumBars%,-1,1) DO SET Meter=!Meter!I
	FOR /L %%A IN (%NumSpaces%,-1,1) DO SET Meter=!Meter! 

	:: Display the progress meter in the title bar and return to the main program
	TITLE Progress:  [%Meter%]  %ProgressPercent%%%
	ENDLOCAL
GOTO :EOF

:root_loop
	cls
	call:header
	for /f "tokens=1,2,* delims=_m " %%A in ('"findstr /b /c:":root_m" "%~f0""') do echo.  %%B  %%C
	
	set choice=
	echo.&set /p choice=Please make a selection or hit ENTER to return: ||GOTO:EOF
	echo.&call:root_m%choice%
	goto:menu_loop
	
:recovery_loop
	cls
	call:header
	for /f "tokens=1,2,* delims=_m " %%A in ('"findstr /b /c:":recovery_m" "%~f0""') do echo.  %%B  %%C
	
	set choice=
	echo.&set /p choice=Please make a selection or hit ENTER to return: ||GOTO:menu_loop
	echo.&call:recovery_m%choice%
	goto:menu_loop
	

:root_m1 PSNEUTER EXPLOIT
	call:rootratc
	goto:root_loop
	
:root_m2 ZERGRUSH EXPLOIT (WIP)
	call:rootzergrush
	goto:root_loop
	
:recovery_m1 GNM 3.06 (Recommended)
	call:recoverygnm
	goto:recovery_loop
	
:recovery_m2 Stock Recovery
	call:recoverystock
	goto:recovery_loop

:boot_1 Normal (4001)
	cmd /c files\adb shell reboot
	echo. --                                                  --
	echo. - The device has been told to reboot in Normal Mode. -
	echo. --                                                  --
	files\sleep 5
	cls
	GOTO:menu_loop
	
:boot_2 Recovery (5001)
	cmd /c files\adb shell reboot recovery
	echo. --                                                    --
	echo. -  Device has beeen told to reboot into Recovery mode  -
	echo. --                                                    --
	files\sleep 5
	cls
	GOTO:menu_loop
	
:download_stock_recovery
	files\wget -O recoveryflash\stockrecovery.img http://goo.gl/mzY2A
	goto:eof

:download_stock_recoveryflash
	files\wget -O recoveryflash\stockrecoveryflash.sh http://goo.gl/F2cWB
	goto:eof
	
:download_tdm_cm9
	mkdir roms\TDM
	files\wget -O roms\TDM\quattrimus-VS660-cm9-beta2.zip http://goo.gl/kFhMC
	goto:eof
	
:download_bobzhome_cm7
	mkdir roms\BobZhome
	files\wget -O roms\BobZhome\CM7.2.0RC0-VS660-BobZhome-120211.zip  http://goo.gl/EBuVC
	goto:eof
	
:download_gapps_cm7
	mkdir roms\gapps
	mkdir roms\gapps\cm7
	files\wget -O roms\gapps\cm7\gapps-gb-20110828-signed.zip http://goo.gl/iH8Hb
	goto:eof
	
:download_gapps_cm9
	mkdir roms\gapps
	mkdir roms\gapps\cm9
	files\wget -O roms\gapps\cm9\gapps-ics-20120429-signed.zip http://goo.gl/pnF8R
	goto:eof
	
:download_mwisbest_2.2.1
	mkdir roms\MWisBest
	files\wget -O roms\MWisBest\LightningC-v1.2.zip http://goo.gl/NsENh
	goto:eof
	
:rootcomplete
	echo.
	echo. ***********************************************
	echo. *               Root Installed                *
	echo. ***********************************************
	echo.
	echo. Root get!
	echo. With great power, comes great responsibility.
	echo.
	echo. Please be careful with how you use root.
	echo.
	goto:eof
	
:roml_loop
	cls
	call:headerrom
	echo.
	echo Roms will be moved to %location%
	echo.
	for /f "tokens=1,2,* delims=_ " %%A in ('"findstr /b /c:":rom_" "%~f0""') do echo.  %%B  %%C

	set choice=
	echo.&set /p choice=Please make a selection or hit ENTER to exit: ||GOTO:menu_loop
	echo.&call:rom_%choice%
	GOTO:menu_loop
	
rem ROMS


:rom_1 BobZhome's CM 7 ROM [12/02/11]
	cls
	call:headerBob
	for /f "tokens=1,2,* delims=_ " %%A in ('"findstr /b /c:":cm7_" "%~f0""') do echo.  %%B  %%C

	set choice=
	echo.&set /p choice=Please make a selection or hit ENTER to exit: ||GOTO:roml_loop
	echo.&call:cm7_%choice%
	GOTO:roml_loop

:rom_2 TDM CM9 [08/04/12]
	cls
	call:headerTDM
	for /f "tokens=1,2,* delims=_ " %%A in ('"findstr /b /c:":cm9_" "%~f0""') do echo.  %%B  %%C

	set choice=
	echo.&set /p choice=Please make a selection or hit ENTER to exit: ||GOTO:roml_loop
	echo.&call:cm9_%choice%
	GOTO:roml_loop
	
:rom_3 MWisBest's LighningC [03/14/11] (A2.2.1)
	cls
	call:headerMW
	for /f "tokens=1,2,* delims=_ " %%A in ('"findstr /b /c:":lightning_" "%~f0""') do echo.  %%B  %%C

	set choice=
	echo.&set /p choice=Please make a selection or hit ENTER to exit: ||GOTO:roml_loop
	echo.&call:lightning_%choice%
	goto:roml_loop
	
rem ROM SUBMENU

:cm7_1 Download & Push ROM
	cls
	call:adbnetwork
	set cm7name=CM7.2.0RC0-VS660-BobZhome-120211.zip
	echo Checking if ROM Exists....
	IF EXIST roms\BobZhome\%cm7name% (
		echo. %cm7name% has been found.
		echo.
	) else (
		echo. %cm7name% is missing.
		echo. So we will download it for you!
		echo.
		
		call:download_bobzhome_cm7
	)
	%title%
	echo Preparing Files...
	rem I just needed to, well give it a break.
	files\sleep 2
	cls
	echo Pushing ROM... (This may take awhile.)
	echo ------------------------------------------------
	files\adb push roms\BobZhome\%cm7name% %location%/%cm7name%
	
	echo Pushing GAPPS... (This may take awhile.)
	echo ------------------------------------------------
	files\adb push roms\gapps\cm7\gapps-gb-20110828-signed.zip /sdcard/gapps/cm7/gapps-gb-20110828-signed.zip
	
	echo All Done!
	echo ------------------------------------------------
	
	files\sleep 2
	
	echo Reboting Phone into Recovery...
	echo ------------------------------------------------
	
	files\adb reboot recovery
	pause
	Goto:rom_1
	
:cm7_2 Vist The Forums
	start http://androidforums.com/vortex-all-things-root/433954-rom-wip-cm7-port-vortex-vs660.html
	goto:rom_1
	
:cm9_1 Download & Push ROM
	cls
	call:adbnetwork
	set cm9name=quattrimus-VS660-cm9-beta2.zip
	echo Checking if ROM Exists....
	IF EXIST roms\TDM\%cm9name% (
		echo. %cm9name% has been found.
		echo.
	) else (
		echo. %cm9name% is missing.
		echo. So we will download it for you!
		echo.
		
		call:download_tdm_cm9
	)
	%title%
	echo Preparing Files...
	rem I just needed to, well give it a break.
	files\sleep 2
	cls
	echo Pushing ROM... (This may take awhile.)
	echo ------------------------------------------------
	files\adb push roms\TDM\%cm9name% %location%/quattrimus-VS660-cm9-beta2.zip
	
	echo Pushing GAPPS... (This may take awhile.)
	echo ------------------------------------------------
	files\adb push roms\gapps\cm7\gapps-ics-20120429-signed.zip sdcard/roms/gapps/cm9/gapps-ics-20120429-signed.zip
	
	echo All Done!
	echo ------------------------------------------------
	
	files\sleep 2
	
	echo Reboting Phone into Recovery...
	echo ------------------------------------------------
	
	files\adb reboot recovery
	pause
	Goto:rom_2
	
:cm9_2 Vist the Forums
	start http://forums.androidcentral.com/lg-vortex/186116-rom-beta-quattrimus-ics.html
	goto:rom_2
	
:cm9_3 Vist the Website
	start http://getquattrimus.com/
	goto:rom_2

:lightning_1 Download & Push ROM
	cls
	call:adbnetwork
	set romname=LightningC-v1.2.zip
	echo Checking if ROM Exists....
	IF EXIST roms\MWisBest\%romname% (
		echo. %romname% has been found.
		echo.
	) else (
		echo. %romname% is missing.
		echo. So we will download it for you!
		echo.
		mkdir roms\MWisBest
		files\wget -O roms\MWisBest\LightningC-v1.2.zip http://goo.gl/NsENh
		
	)
	%title%
	echo Preparing Files...
	rem I just needed to, well give it a break.
	files\sleep 2
	cls
	echo Pushing ROM... (This may take awhile.)
	echo ------------------------------------------------
	cmd /c files\adb shell mkdir /sdcard/roms
	files\adb push roms\MWisBest\LightningC-v1.2.zip /sdcard/roms/LightningC-v1.2.zip
	
	echo All Done!
	echo ------------------------------------------------
	
	files\sleep 2
	
	echo Reboting Phone into Recovery...
	echo ------------------------------------------------
	
	rem files\adb reboot recovery
	pause
	Goto:rom_3
	
:lightning_2 Vist the Forums
	start http://androidforums.com/vortex-all-things-root/297147-rom-lightningc-v1-2-3-14-11-a.html
	goto:rom_3
	
rem rom headers

:headerMW
	echo. ***************************************
	echo. *      MWisBest's LightningC ROM      *
	echo. ***************************************
	echo. *         Support this Dev!           *
	echo. ***************************************
	goto:eof
	
:headerBOB	
	echo. ***************************************
	echo. *     BobZhomes CyanogenMod7 ROM      *
	echo. ***************************************
	echo. *         Support this Dev!           *
	echo. ***************************************
	goto:eof
	
:headerTDM
	echo. ***************************************
	echo. *        TDM CyanogenMod9 ROM         *
	echo. ***************************************
	echo. *         Support this Dev!           *
	echo. ***************************************
	goto:eof
	
:bootheader
	echo. ***************************************
	echo. *         Boot Mode Selector          *
	echo. ***************************************
	goto:eof
	
:extrasheader
	echo. ***************************************
	echo. *             Extras Menu             *
	echo. ***************************************
	echo. 
	echo. These are in Alpha, they may/may not
	echo. work.
	echo.
	goto:eof
	
rem Extras!

:extra_1 Swype Beta 1.3
	cls
	echo. This will replace Stock Swype with Swype Beta 1.3
	echo. Backups in /sdcard/swype_backup
	files\adb shell mkdir /mnt/sdcard/swype_backup
	files\asb remount
	files\adb shell mount -o rw,remount /dev/block/mmcblk0p12 /system
	files\adb shell cp /system/app/Swype.apk /mnt/sdcard/swype_backup
	files\adb shell cp /system/lib/libSwypeCore.so /mnt/sdcard/swype_backup
	files\adb shell rm /system/app/Swype.apk
	files\adb shell rm /system/lib/libSwypeCore.so
	echo. Swype is now removed...
	echo. Downloading latest installer!
	pause
	echo. Warning, this is EXTREMLY BETA.
	echo. -------------------------------------------
	cd root
	mkdir Swype
	cd..
	set s=Swype.apk
		IF EXIST root/Swype/Swype.apk (
		echo. %s% has been found.
		echo.
	) else (
		echo. %s% is missing.
		echo. So we will download it for you!
		echo.
		files\wget --no-check-certificate -O root/Swype/Swype.apk http://goo.gl/kgQAN
		
	)
	%title%
	cls
	echo. Installing Swype...
	files\adb install root/Swype/Swype.apk
	echo. All Done!
	cls
	echo Now, go to Settings > Language & Keyboard  and 'Check'
	echo Swype Beta 1.3
	echo. Enjoy!
	pause
	goto:option_10
	
:extra_2 Swype Stock
	set s=Swype.apk
	echo Diddn't like Swype Beta 1.3? That sucks!
	echo Reinstalling Swype Stock!
	files\sleep 2
	mkdir root\Swype
	mkdir root\Swype\Stock
		IF EXIST root/Swype/Stock/Swype.apk (
		echo. %s% has been found.
		echo.
	) else (
		echo. %s% is missing.
		echo. So we will download it for you!
		echo.
		files\wget --no-check-certificate -O root/Swype/Stock/Swype.apk http://goo.gl/iBXD7
	)
		if EXIST root/Swype/Stock/libSwypeCore.so (
		echo. %s% has been found.
		echo.
	) else (
		echo. %s% is missing.
		echo So we willd ownlaod it for you!
		echo.
		files\wget -O root/Swype/Stock/libSwypeCore.so http://goo.gl/Awg7I
	)
	%title%
	cls
	echo. Uninstalling Previous Swype.
	files\adb shell rm "/data/app/com.nuance.swype.beta-1.apk"
	files\adb push root/Swype/Stock/Swype.apk /sdcard/ss/Swype.apk
	files\adb push root/Swype/Stock/Swype.apk /sdcard/ss/libSwypeCore.so
	files\adb shell cat /sdcard/ss/libSwypeCore.so /system/lib/libSwypeCore.so
	files\adb shell cat /sdcard/ss/Swype.apk /system/app/Swype.apk
	echo Rebooting Phone so app can take effect.
	files\sleep 1
	rem files\adb reboot
	files\adb wait-for-device
	echo. Should now have Stock Swype Back!
	pause
	goto:option_10
	
:pbtitle
	SET p=Progress:
	if %t% == 0 call:pb1
	if %t% == 20 call:pb2
	if %t% == 40 call:pb3
	if %t% == 60 call:pb4
	if %t% == 80 call:pb5
	if %t% == 100 call:pb6
	if %t% == 120 call:wtf
goto:eof

:pb1
	title %p% 0%
goto:eof

:pb2
	title %p% 20%
goto:eof

:pb3
	title %p% 40%
goto:eof

:pb4
	title %p% 60%
goto:eof

:pb5
	title %p% 80%
goto:eof

:pb6
	title %p% 100%
goto:eof

:wtf
	title IT'S OVER 100% AHHHHHHHHH!
goto:eof

:update
	cls
	call:updateheader
	echo According to the server, there is a update available.
	echo Would you like too update?
	SET /P update=[Y or N]
	if %update% == y call:updateyes
	if NOT %update% == y call:updateno
goto:eof

:updateyes
	echo Downloading Update... (May Take Awhile)
	files\sleep 1
	files\wget -q -O %updatename% %lurl%
	echo Done!
	files\sleep 1
	%title%
	echo Update is called "%updatename%" in "%updatelocation%"
	files\sleep 2
	echo Returning too menu...
	files\sleep 1
goto:eof

:updateno
	echo Not Downloading Update...
	files\sleep 1
	echo Returning too menu...
	files\sleep 1
goto:menu_loop

:updateheader
	echo. **************************************
	echo. *        Update is Available!        *
	echo. **************************************
	echo. New Version: %lver% - %ldate%
	echo. --------------------------------------
	files\cat files/changelog.log
	echo.
	echo.
goto:eof

:noupdate
	cls
	echo No Update is available!
	files\sleep 1
	echo Returning to menu...
	files\sleep 2
goto:menu_loop